---
title: KeyframeEffect.KeyframeEffect()
slug: Web/API/KeyframeEffect/KeyframeEffect
tags:
  - API
  - Animation
  - Constructor
  - Experimental
  - KeyframeEffect
  - Reference
  - waapi
  - web animations api
---
<p>{{ SeeCompatTable() }}{{ APIRef("Web Animations API") }}</p>

<p>The <strong><code>KeyframeEffect()</code></strong> constructor of the <a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a> returns a new <code>{{domxref("KeyframeEffect")}}</code> object instance, and also allows you to clone an existing keyframe effect object instance.</p>

<h2 id="Syntax">Syntax</h2>

<div class="syntaxbox">
<pre class="brush: js">var keyframes = new KeyframeEffect(<em>element</em>, <em>keyframeSet</em>, <em>keyframeOptions</em>);
var keyframes = new KeyframeEffect(<em>sourceKeyFrames</em>);
</pre>
</div>

<h3 id="Parameters">Parameters</h3>

<p>The first type of constructor (see above) creates a completely new {{domxref("KeyframeEffect")}} object instance. Its parameters are:</p>

<dl>
 <dt>element</dt>
 <dd>The DOM element to be animated, or <code>null</code>.</dd>
 <dt>keyframeSet</dt>
 <dd>An <a href="/en-US/docs/Web/API/Web_Animations_API/Keyframe_Formats">keyframe object</a> or <code>null</code>.</dd>
 <dt>keyframeOptions {{optional_inline}}</dt>
 <dd>
 <p>Either an integer representing the animation's duration (in milliseconds), or an {{domxref("EffectTiming", "Object")}} containing one or more of the following:<br>
  {{Page("/en-US/docs/Web/API/EffectTiming", "Properties")}}</p>

 <dl>
  <dt>{{domxref("KeyframeEffectReadOnly.composite", "composite")}}</dt>
  <dd>Determines how values are combined between this animation and the element's underlying values.</dd>
  <dt>{{domxref("KeyframeEffectReadOnly.iterationComposite", "iterationComposite")}}</dt>
  <dd>Determines how values build from iteration to iteration in the current animation.</dd>
 </dl>
 </dd>
</dl>

<p>The second type of constructor (see above) creates a clone of an existing  {{domxref("KeyframeEffect")}} object instance. Its parameter is as follows:</p>

<dl>
 <dt>sourceKeyFrames</dt>
 <dd>A {{domxref("KeyframeEffect")}} object that you want to clone.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the <a href="http://codepen.io/rachelnabors/pen/eJyWzm/?editors=0010">Follow the White Rabbit example</a>, the <code>KeyframeEffect</code> constructor is used to create a set of keyframes that dictate how the White Rabbit should animate down the hole:</p>

<pre class="brush: js"> var rabbitDownKeyframes = new KeyframeEffect(
    whiteRabbit, // element to animate
    [
      { transform: 'translateY(0%)' }, // keyframe
      { transform: 'translateY(100%)' } // keyframe
    ],
    { duration: 3000, fill: 'forwards' } // keyframe options
  );
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations 2', '#dom-keyframeeffect-iterationcomposite', 'KeyframeEffectOptions.iterationComposite' )}}</td>
   <td>{{Spec2('Web Animations 2')}}</td>
   <td>Added the <code>iterationComposite</code> option.</td>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations', '#dom-keyframeeffect-keyframeeffect', 'keyframeEffect()' )}}</td>
   <td>{{Spec2('Web Animations')}}</td>
   <td>Editor's draft.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.KeyframeEffect.KeyframeEffect")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/KeyframeEffect">KeyframeEffect Interface</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a></li>
 <li>{{domxref("Animation")}}</li>
</ul>
